﻿using Chapter09;

namespace AddisonWesley.Michaelis.EssentialCSharp.Chapter09.Listing09_17
{
    /// <summary>
    /// Typ DataStorage służy do utrwalania i pobierania
    /// zapisywanych w pliku danych o pracownikach.
    /// </summary>
    class DataStorage
    {
        /// <summary>
        /// Zapisuje obiekt employee do pliku
        /// o nazwie odpowiadającej nazwisku i imieniu pracownika.
        /// </summary>
        /// <remarks>
        /// Ta metoda używa typu 
        /// <seealso cref="System.IO.FileStream"/>
        /// oraz typu
        /// <seealso cref="System.IO.StreamWriter"/>
        /// </remarks>
        /// <param name="employee">
        /// Utrwalany w pliku obiekt typu Employee</param>
        /// <date>1 stycznia 2000</date>

        public static void Store(Employee employee)
        {
            // ...
        }

        /** <summary>
         * Wczytuje obiekt typu Employee
         * </summary>
         * <remarks>
         * Ta metoda używa typu
         * <seealso cref="System.IO.FileStream"/>
         * i typu
         * <seealso cref="System.IO.StreamReader"/>
         * </remarks>
         * <param name="firstName">
         * Imię pracownika</param>
         * <param name="lastName">
         * Nazwisko pracownika</param>
         * <returns>
         * Obiekt typu Employee z imieniem i nazwiskiem pracownika
         * </returns>
         * <date>1 stycznia 2000</date> **/
        public static Employee Load(string firstName, string lastName)
        {
            // ...
            return new Employee();
        }
    }

    class Program
    {
        // ...
    }
}